#ifndef CSTRING
#define CSTRING
#include <windows.h>

class NewCString{
private:
	PCHAR Data;
	typedef struct StringData {
		int Length;
		int hash;
		int refCount;         
	};

public:
	NewCString();
	NewCString(LPCSTR str);
	NewCString(CHAR str);
	NewCString(const NewCString& str);
	~NewCString();

	NewCString& operator=(NewCString& str);
	NewCString& operator=(LPCSTR str);
	NewCString& operator=(char str);
	NewCString& operator+(NewCString& str);
	NewCString& operator+(LPCSTR str);
	NewCString& operator+(char str);
	NewCString& operator+=(NewCString& str);
	NewCString& operator+=(LPCSTR str);
	NewCString& operator+=(char str);
	void toLowerCase();
	bool operator==(NewCString& str);
	bool operator==(LPCSTR str);
	bool operator==(char str);
	int GetLength();
	int GetHash();
	operator LPCSTR();
	bool operator!=(NewCString& str);
	bool operator!=(LPCSTR str);
	int Find(NewCString& str);
	int Find(LPCSTR str);
	int Find(char str);
//	PCHAR FormatV(LPCSTR Format, va_list args);
	NewCString& FormatString(LPCSTR format, ...);
	void AppendChar(char str);
	PCHAR GetBufferSetLength(int Length);
	PCHAR GetBuffer();
};

NewCString& operator+(LPCSTR str1, NewCString& str2);
NewCString& operator+(char str1, NewCString& str2);
#endif //CSTRING